## The library is under development and is updated and corrected as needed!

```env
  REACT_APP_SQLITE_DB_NAME = 'arm.db'
  REACT_APP_SQLITE_TABLE_SETTINGS = 'Config'  for using class SLStore
```


```js
    import { SLStore, Sqlite } from '@utils/SQLite/SqliteClass';

```

###### return Promise

```js
    Sqlite.checkTable()//All tables. list in console
    Sqlite.checkTable(nameTable)//
    Sqlite.setDataT(nameTable, payload, options) 
    /* options
      {
        isCreateDate: false //no create column createdAt and updateAt. default: true
        rewriteTable: true; //added request `DROP TABLE IF EXISTS ${nameTable}`
      }
    */  

    Sqlite.updateDataT(nameTable, payload, { where, stringWhere, condition })

    /*
      {
        where: {name: 'Jon', age: 30} // generate WHERE name="Jon" AND age="30"
        condition: "AND" | "OR" //edit WHERE name="Jon" OR age="30"

        stringWhere: "WHERE name='Jon'" // manual setup WHERE
      }
    */


    Sqlite.getDataT(nameTable, { where, whereKey, ignoreWhere, stringWhere, condition })

    Sqlite.removeData(nameTable, { where, whereKey, ignoreWhere, stringWhere, condition })

    /*
      {
        whereArrKey: {name: ['Jon', "Brain"], age: [25, 30]}}
      }
      'DELETE FROM ${nameTable} WHERE name = "Jon" OR name = "Brain", age = "17" OR age = "20"'
    */
```
   ### Example
```js
    Sqlite.removeData('Test', {where: {key: 'Jon', age: 20}})
    //DELETE FROM Test WHERE key="Jon" OR age="20"

    Sqlite.removeData('Test', {whereKey: {key: ['Jon', 'Brain']} })
    //DELETE FROM Test WHERE key = "Jon" OR key = "Brain"
    Sqlite.removeData('Test', {whereKey: {key: ['Jon', 'Brain']}, ignoreWhere: {key: ['Jon', 'Alex']}, condition: 'AND'})
    //DELETE FROM Test WHERE key != "Jon" AND key = "Brain" AND key != "Alex"

    Sqlite.removeData('Test', {ignoreWhere: {key: ['Jon']} })
    //DELETE FROM Test WHERE key != "Jon"

    Sqlite.removeData('Test', {})
    //DELETE FROM Test    

    Sqlite.removeData('Test', {stringWhere: "WHERE name = 'Jon' OR name = 'Brain'"})
    //DELETE FROM Test WHERE name = 'Jon' OR name = 'Brain'

    /*---------------------------------------------------------------------------*/


    Sqlite.dropTable(nameTable)

```


#### SLStore

The class aims to save data if cordova in sqlite, if web in localStorage. Most of it repeats the functionality of localStorage.

The table contains the "key" and "value" columns

```js

  SLStore.setItemT(key, value, options)// options from Sqlite.setDataT
  SLStore.getItem(key)//{ msg:string, status:boolean, data: {[key]: any} }
  SLStore.getItems(options)
  /*options
    ignoreKeys: ['isDarkTheme']
  */
  //return -> { msg:string, status:boolean, data: {[key]: any, [key]: any} }
  SLStore.removeItem(keys, ignoreKey?: [''])//['Jon', 'Brain']
  SLStore.dropAllData()//for cordova drop table REACT_APP_SQLITE_TABLE_SETTINGS, for web localStorage.clear();


```